Index: trunk/autoquest-plugin-uml-test/src/test/resources/ita_imported_model.uml
===================================================================
--- trunk/autoquest-plugin-uml-test/src/test/resources/ita_imported_model.uml	(revision 2001)
+++ trunk/autoquest-plugin-uml-test/src/test/resources/ita_imported_model.uml	(revision 2012)
@@ -447,7 +447,7 @@
             <type xmi:type="uml:Component" href="LogisticsSAUT.uml#_hdknECZIEeWZtLKubi-lUg"/>
           </ownedAttribute>
-          <ownedAttribute xmi:type="uml:Port" xmi:id="_dGhtAOg8EeSdr4WV9xKYvQ" name="port__TransportService" type="_UXyBgBmPEeWtwIP2ghB3AA" aggregation="composite"/>
-          <ownedAttribute xmi:type="uml:Port" xmi:id="_pqWZ8Og8EeSdr4WV9xKYvQ" name="port__WarehouseService" type="_UXyokBmPEeWtwIP2ghB3AA" aggregation="composite"/>
-          <ownedAttribute xmi:type="uml:Port" xmi:id="_tu2KIOg8EeSdr4WV9xKYvQ" name="port__MaterialSupplier" type="_UXz2sBmPEeWtwIP2ghB3AA" aggregation="composite"/>
+          <ownedAttribute xmi:type="uml:Port" xmi:id="_dGhtAOg8EeSdr4WV9xKYvQ" name="port__TransportService" aggregation="composite"/>
+          <ownedAttribute xmi:type="uml:Port" xmi:id="_pqWZ8Og8EeSdr4WV9xKYvQ" name="port__WarehouseService" aggregation="composite"/>
+          <ownedAttribute xmi:type="uml:Port" xmi:id="_tu2KIOg8EeSdr4WV9xKYvQ" name="port__MaterialSupplier" aggregation="composite"/>
         </packagedElement>
         <packagedElement xmi:type="uml:Component" xmi:id="_JjYS8Og7EeSdr4WV9xKYvQ" name="WarehouseTC">
@@ -679,7 +679,7 @@
       </ownedComment>
       <ownedAttribute xmi:id="_TVTAIv4MEeSo7_KDXCc_CQ" name="materialSupplierService" type="_JCAboBBFEeWznssMC0Wg3A"/>
-      <ownedAttribute xmi:id="_TVTAI_4MEeSo7_KDXCc_CQ" name="pointOfSaleService" type="_fjyoYOg2EeSdr4WV9xKYvQ"/>
+      <ownedAttribute xmi:id="_TVTAI_4MEeSo7_KDXCc_CQ" name="pointOfSaleService" type="_su0-0CusEeWO3p7JFLkS1g"/>
       <ownedConnector xmi:id="_EVbNMBBEEeWznssMC0Wg3A" name="Connector1">
-        <end xmi:id="_EVgFsBBEEeWznssMC0Wg3A" partWithPort="_TVTAI_4MEeSo7_KDXCc_CQ" role="_tu2KIOg8EeSdr4WV9xKYvQ">
+        <end xmi:id="_EVgFsBBEEeWznssMC0Wg3A" partWithPort="_TVTAI_4MEeSo7_KDXCc_CQ" role="_su0-0iusEeWO3p7JFLkS1g">
           <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_EVgFsRBEEeWznssMC0Wg3A" value="1"/>
           <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_EVgFshBEEeWznssMC0Wg3A" value="1"/>
@@ -696,7 +696,8 @@
           <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_-YzL0xBFEeWznssMC0Wg3A" value="1"/>
         </end>
-        <end xmi:id="_-Yzy4BBFEeWznssMC0Wg3A" partWithPort="_TVTAI_4MEeSo7_KDXCc_CQ" role="_mBYW4Og2EeSdr4WV9xKYvQ">
+        <end xmi:id="_-Yzy4BBFEeWznssMC0Wg3A" partWithPort="_TVTAI_4MEeSo7_KDXCc_CQ">
           <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_-Yzy4RBFEeWznssMC0Wg3A" value="1"/>
           <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_-Yzy4hBFEeWznssMC0Wg3A" value="1"/>
+          <role xmi:type="uml:Port" href="LogisticsSAUT.uml#_hojvECZIEeWZtLKubi-lUg"/>
         </end>
       </ownedConnector>
@@ -705,24 +706,4 @@
       <packagedElement xmi:type="uml:Artifact" xmi:id="_49f44AozEeW1K6gnMDTfww" clientDependency="_7z5eQAozEeW1K6gnMDTfww" name="Artifact1" fileName="">
         <manifestation xmi:id="_7z5eQAozEeW1K6gnMDTfww" name="Manifestation2" client="_49f44AozEeW1K6gnMDTfww" supplier="_TVTAIP4MEeSo7_KDXCc_CQ _dmDckLEQEeSnYZTmeJXZKg _JCAboBBFEeWznssMC0Wg3A" utilizedElement="_TVTAIP4MEeSo7_KDXCc_CQ"/>
-      </packagedElement>
-      <packagedElement xmi:type="uml:Component" xmi:id="_UT18sBmPEeWtwIP2ghB3AA" clientDependency="_UXwMUBmPEeWtwIP2ghB3AA" name="IITAPointOfSale_Mirrored">
-        <packagedElement xmi:type="uml:Usage" xmi:id="_UXwMUBmPEeWtwIP2ghB3AA" name="" client="_UT18sBmPEeWtwIP2ghB3AA">
-          <supplier xmi:type="uml:Interface" href="LogisticsSAUT.uml#_hdkAACZIEeWZtLKubi-lUg"/>
-        </packagedElement>
-      </packagedElement>
-      <packagedElement xmi:type="uml:Component" xmi:id="_UXyBgBmPEeWtwIP2ghB3AA" clientDependency="_UXyBgRmPEeWtwIP2ghB3AA" name="IITATransport_Mirrored">
-        <packagedElement xmi:type="uml:Usage" xmi:id="_UXyBgRmPEeWtwIP2ghB3AA" name="" client="_UXyBgBmPEeWtwIP2ghB3AA">
-          <supplier xmi:type="uml:Interface" href="LogisticsSAUT.uml#_hosR8CZIEeWZtLKubi-lUg"/>
-        </packagedElement>
-      </packagedElement>
-      <packagedElement xmi:type="uml:Component" xmi:id="_UXyokBmPEeWtwIP2ghB3AA" clientDependency="_UXzPoBmPEeWtwIP2ghB3AA" name="IITAWarehouse_Mirrored">
-        <packagedElement xmi:type="uml:Usage" xmi:id="_UXzPoBmPEeWtwIP2ghB3AA" name="" client="_UXyokBmPEeWtwIP2ghB3AA">
-          <supplier xmi:type="uml:Interface" href="LogisticsSAUT.uml#_hARAACZIEeWZtLKubi-lUg"/>
-        </packagedElement>
-      </packagedElement>
-      <packagedElement xmi:type="uml:Component" xmi:id="_UXz2sBmPEeWtwIP2ghB3AA" clientDependency="_UXz2sRmPEeWtwIP2ghB3AA" name="IITAMaterialSupplier_Mirrored">
-        <packagedElement xmi:type="uml:Usage" xmi:id="_UXz2sRmPEeWtwIP2ghB3AA" name="" client="_UXz2sBmPEeWtwIP2ghB3AA">
-          <supplier xmi:type="uml:Interface" href="LogisticsSAUT.uml#_hywz8CZIEeWZtLKubi-lUg"/>
-        </packagedElement>
       </packagedElement>
       <packagedElement xmi:type="uml:Artifact" xmi:id="_RgNpICPwEeWoisiMbESVVw" clientDependency="_RgNpISPwEeWoisiMbESVVw" name="Artifact2" fileName="">
@@ -736,9 +717,19 @@
       </profileApplication>
     </packagedElement>
-    <packagedElement xmi:type="uml:Component" xmi:id="_JCAboBBFEeWznssMC0Wg3A" name="BusinessUnitSAUT">
+    <packagedElement xmi:type="uml:Component" xmi:id="_JCAboBBFEeWznssMC0Wg3A" name="SAUT_BU">
       <generalization xmi:id="_Ra1HwBBFEeWznssMC0Wg3A">
         <general xmi:type="uml:Component" href="LogisticsSAUT.uml#_iFMnwyZIEeWZtLKubi-lUg"/>
       </generalization>
-      <ownedAttribute xmi:type="uml:Port" xmi:id="_VoZUYBBFEeWznssMC0Wg3A" name="port_PointOfSale" type="_UT18sBmPEeWtwIP2ghB3AA" aggregation="composite"/>
+      <ownedAttribute xmi:type="uml:Port" xmi:id="_VoZUYBBFEeWznssMC0Wg3A" name="PointOfSaleReferenceImplementationServicePort" aggregation="composite" isConjugated="true">
+        <type xmi:type="uml:Component" href="LogisticsSAUT.uml#_hdknECZIEeWZtLKubi-lUg"/>
+      </ownedAttribute>
+    </packagedElement>
+    <packagedElement xmi:type="uml:Component" xmi:id="_su0-0CusEeWO3p7JFLkS1g" name="SAUT_PoS">
+      <generalization xmi:id="_su0-0SusEeWO3p7JFLkS1g">
+        <general xmi:type="uml:Component" href="LogisticsSAUT.uml#_hoalIyZIEeWZtLKubi-lUg"/>
+      </generalization>
+      <ownedAttribute xmi:type="uml:Port" xmi:id="_su0-0iusEeWO3p7JFLkS1g" name="BusinessUnitReferenceImplementationServicePort" aggregation="composite" isConjugated="true">
+        <type xmi:type="uml:Component" href="LogisticsSAUT.uml#_hyxbACZIEeWZtLKubi-lUg"/>
+      </ownedAttribute>
     </packagedElement>
     <profileApplication xmi:id="_Ca5hkLEKEeSnYZTmeJXZKg">
@@ -790,8 +781,7 @@
   <utp:TestComponent xmi:id="_Ps1BcP4IEeSo7_KDXCc_CQ" base_Property="_4npOwOgzEeSdr4WV9xKYvQ"/>
   <utp:TestContext xmi:id="_YCbdoP4MEeSo7_KDXCc_CQ" base_BehavioredClassifier="_TVTAIP4MEeSo7_KDXCc_CQ" base_StructuredClassifier="_TVTAIP4MEeSo7_KDXCc_CQ"/>
-  <utp:SUT xmi:id="_ZhIQQP4MEeSo7_KDXCc_CQ" base_Property="_TVTAIv4MEeSo7_KDXCc_CQ"/>
   <utp:TestCase xmi:id="_70ytwP4MEeSo7_KDXCc_CQ"/>
   <mdta:Platform xmi:id="_MoPvwAo1EeW1K6gnMDTfww" base_Package="_IWbVQAo1EeW1K6gnMDTfww">
-    <level xmi:id="_YLdgECbYEeWkOuq7zDNJsg">fokusmbt</level>
+    <level>fokusmbt</level>
   </mdta:Platform>
   <testingmm:TestDeployment xmi:id="_pWG8gAtgEeW1K6gnMDTfww" base_Artifact="_49f44AozEeW1K6gnMDTfww"/>
@@ -810,4 +800,13 @@
   <mdta:PlatformTrace xmi:id="_TGzUIBZVEeWeIIcS3ciOzw" sourcePlatform="fokusmbt" targetPlatform="fokusmbt"/>
   <utp:TestCase xmi:id="_nk5FAB0QEeWG-sbfjQSITw" base_Operation="_mlZW4B0QEeWG-sbfjQSITw"/>
-  <testingmm:TestDeployment xmi:id="_41geYCP5EeWoisiMbESVVw" base_Artifact="_RgNpICPwEeWoisiMbESVVw"/>
+  <utp:TestCase xmi:id="_3qW3cCb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_35GeECb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_35_18Cb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_37Mv0Cb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_38LnQCb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_390mASb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_3_1YMSb6EeWasqsn8e4zVw"/>
+  <utp:TestCase xmi:id="_4BI_wCb6EeWasqsn8e4zVw"/>
+  <utp:SUT xmi:id="_B2y3ECutEeWO3p7JFLkS1g" base_Property="_TVTAI_4MEeSo7_KDXCc_CQ"/>
+  <utp:TestComponent xmi:id="_DWPQkCutEeWO3p7JFLkS1g" base_Property="_TVTAIv4MEeSo7_KDXCc_CQ"/>
 </xmi:XMI>