Index: trunk/autoquest-plugin-uml-test/src/test/resources/deda_model.uml
===================================================================
--- trunk/autoquest-plugin-uml-test/src/test/resources/deda_model.uml	(revision 2012)
+++ trunk/autoquest-plugin-uml-test/src/test/resources/deda_model.uml	(revision 2013)
@@ -14,8 +14,8 @@
       <packagedElement xmi:type="uml:Package" xmi:id="_IcdwwB5KEeWNPL_d9NJ0qw" name="imported">
         <packageImport xmi:id="_5y4RNh5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/RLUSMetaData.uml#_sRiE7xwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="RLUSMetaData.uml#_sRiE7xwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qIB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/HL7.uml#_ejdybxwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="HL7.uml#_ejdybxwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_puJM0B5KEeWNPL_d9NJ0qw">
@@ -27,61 +27,61 @@
       <packagedElement xmi:type="uml:Package" xmi:id="_D2KekB5LEeWNPL_d9NJ0qw" name="imported">
         <packageImport xmi:id="_e1D_4B5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/RLP.uml#_ejXrwRwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="RLP.uml#_ejXrwRwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4ROx5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/XDW.uml#_ejRlIBwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="XDW.uml#_ejRlIBwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4ROh5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/ws-humantask-types.uml#_eeOGAhwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="ws-humantask-types.uml#_eeOGAhwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4ROR5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/rlusxdwservice.uml#_eigwMBwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="rlusxdwservice.uml#_eigwMBwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4ROB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/RLUSTypes.uml#_eiOcTxwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="RLUSTypes.uml#_eiOcTxwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RNx5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/rlusrlpnotesservice.uml#_eUpTQRwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="rlusrlpnotesservice.uml#_eUpTQRwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RNR5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/RLUSMetaData.uml#_eYLIYRwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="RLUSMetaData.uml#_eYLIYRwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RNB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/RLUSExpression.uml#_efFBshwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="RLUSExpression.uml#_efFBshwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RMx5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/rluscda2reportservice.uml#_eXB44RwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="rluscda2reportservice.uml#_eXB44RwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RMR5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrlusxdw.uml#_ejFX4RwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrlusxdw.uml#_ejFX4RwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qJx5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrlusrlpnotes.uml#_eegZ7xwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrlusrlpnotes.uml#_eegZ7xwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qJR5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrluscda2report.uml#_ee40bxwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrluscda2report.uml#_ee40bxwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qIx5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrluscda2prescrizionesac.uml#_ed9nURwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrluscda2prescrizionesac.uml#_ed9nURwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3DEB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/cda2prescrizionesac_types.uml#_eiCPARwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="cda2prescrizionesac_types.uml#_eiCPARwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RMh5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrlusxdw.uml#_tcrpZxwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrlusxdw.uml#_tcrpZxwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y4RMB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrlusrlpnotes.uml#_spLv8hwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrlusrlpnotes.uml#_spLv8hwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qJB5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrluscda2prescrizionesac.uml#_sWA8QxwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrluscda2prescrizionesac.uml#_sWA8QxwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qJh5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/midasrluscda2report.uml#_srSBrRwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="midasrluscda2report.uml#_srSBrRwAEeWtNMMjZV-FEA"/>
         </packageImport>
       </packagedElement>
       <packagedElement xmi:type="uml:Component" xmi:id="_ZpHIUB5dEeW1E_G5zMqVNw" name="RLUSTestSuite">
         <ownedAttribute xmi:id="_MxW9UB5eEeW1E_G5zMqVNw" name="rlusRLPNotesService" visibility="public">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrlusrlpnotes.uml#_sq_tyhwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrlusrlpnotes.uml#_sq_tyhwAEeWtNMMjZV-FEA"/>
           <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_OX4PMB5eEeW1E_G5zMqVNw" value="1"/>
           <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_OX42QB5eEeW1E_G5zMqVNw" value="1"/>
@@ -92,11 +92,11 @@
         <ownedAttribute xmi:id="_nZmKwB5fEeW1E_G5zMqVNw" name="RLUSTestEnvironment" type="_Mdd7gB5fEeW1E_G5zMqVNw"/>
         <ownedAttribute xmi:id="_zmXXsB5hEeW1E_G5zMqVNw" name="rlusXDWService">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrlusxdw.uml#_tefnRBwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrlusxdw.uml#_tefnRBwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:id="_gx2zAB5lEeW1E_G5zMqVNw" name="rLUSCDA2ReportService">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrluscda2report.uml#_ss_46hwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrluscda2report.uml#_ss_46hwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:id="_hEry8B5mEeW1E_G5zMqVNw" name="rLUSMetadataService">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/RLUSMetaData.uml#_sUG3yhwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="RLUSMetaData.uml#_sUG3yhwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedConnector xmi:id="_lsmoAB5gEeW1E_G5zMqVNw" name="Connector1">
@@ -108,5 +108,5 @@
             <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_lsn2IR5gEeW1E_G5zMqVNw" value="1"/>
             <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_lsn2Ih5gEeW1E_G5zMqVNw" value="1"/>
-            <role xmi:type="uml:Port" href="hssp_pilot_libs/midasrlusrlpnotes.uml#_srF0YhwAEeWtNMMjZV-FEA"/>
+            <role xmi:type="uml:Port" href="midasrlusrlpnotes.uml#_srF0YhwAEeWtNMMjZV-FEA"/>
           </end>
         </ownedConnector>
@@ -119,5 +119,5 @@
             <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_gmqXBB5iEeW1E_G5zMqVNw" value="1"/>
             <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_gmqXBR5iEeW1E_G5zMqVNw" value="1"/>
-            <role xmi:type="uml:Port" href="hssp_pilot_libs/midasrlusxdw.uml#_telt4RwAEeWtNMMjZV-FEA"/>
+            <role xmi:type="uml:Port" href="midasrlusxdw.uml#_telt4RwAEeWtNMMjZV-FEA"/>
           </end>
         </ownedConnector>
@@ -130,5 +130,5 @@
             <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_7arrwR5lEeW1E_G5zMqVNw" value="1"/>
             <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_7arrwh5lEeW1E_G5zMqVNw" value="1"/>
-            <role xmi:type="uml:Port" href="hssp_pilot_libs/midasrluscda2report.uml#_stF_ghwAEeWtNMMjZV-FEA"/>
+            <role xmi:type="uml:Port" href="midasrluscda2report.uml#_stF_ghwAEeWtNMMjZV-FEA"/>
           </end>
         </ownedConnector>
@@ -141,5 +141,5 @@
             <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_5jY9gR5mEeW1E_G5zMqVNw" value="1"/>
             <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_5jY9gh5mEeW1E_G5zMqVNw" value="1"/>
-            <role xmi:type="uml:Port" href="hssp_pilot_libs/RLUSMetaData.uml#_sUM-YxwAEeWtNMMjZV-FEA"/>
+            <role xmi:type="uml:Port" href="RLUSMetaData.uml#_sUM-YxwAEeWtNMMjZV-FEA"/>
           </end>
         </ownedConnector>
@@ -147,14 +147,14 @@
       <packagedElement xmi:type="uml:Component" xmi:id="_Mdd7gB5fEeW1E_G5zMqVNw" name="RLUSTestEnvironment">
         <ownedAttribute xmi:type="uml:Port" xmi:id="_RPHFkB5fEeW1E_G5zMqVNw" name="rlptestport" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrlusrlpnotes.uml#_spFpRhwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrlusrlpnotes.uml#_spFpRhwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:type="uml:Port" xmi:id="_S9o8kB5iEeW1E_G5zMqVNw" name="xdwtestport" visibility="public" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrlusxdw.uml#_tcliwxwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrlusxdw.uml#_tcliwxwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:type="uml:Port" xmi:id="_vcfbcB5lEeW1E_G5zMqVNw" name="cda2reporttestport" visibility="public" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/midasrluscda2report.uml#_srL7ARwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="midasrluscda2report.uml#_srL7ARwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:type="uml:Port" xmi:id="_rp1zwB5mEeW1E_G5zMqVNw" name="metadatatestport" visibility="public" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/RLUSMetaData.uml#_sRb-QBwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="RLUSMetaData.uml#_sRb-QBwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
       </packagedElement>
@@ -163,16 +163,16 @@
       <packagedElement xmi:type="uml:Package" xmi:id="_QnrpQB5LEeWNPL_d9NJ0qw" name="imported">
         <packageImport xmi:id="_5y3qIR5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/IXS.uml#_egUXxhwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="IXS.uml#_egUXxhwAEeWtNMMjZV-FEA"/>
         </packageImport>
         <packageImport xmi:id="_5y3qIh5JEeWNPL_d9NJ0qw">
-          <importedPackage href="hssp_pilot_libs/IXS.uml#_st87KBwAEeWtNMMjZV-FEA"/>
+          <importedPackage href="IXS.uml#_st87KBwAEeWtNMMjZV-FEA"/>
         </packageImport>
       </packagedElement>
       <packagedElement xmi:type="uml:Component" xmi:id="_RYeG0B5oEeW1E_G5zMqVNw" name="IXSTestSuite">
         <ownedAttribute xmi:id="_z_K1EB5oEeW1E_G5zMqVNw" name="POCDPatientMQService">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/IXS.uml#_tThtYxwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="IXS.uml#_tThtYxwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:id="_1o7BIB5oEeW1E_G5zMqVNw" name="IXSMetadataService">
-          <type xmi:type="uml:Component" href="hssp_pilot_libs/IXS.uml#_tSw4ZBwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Component" href="IXS.uml#_tSw4ZBwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:id="_NPRAUB5pEeW1E_G5zMqVNw" name="IXSTestEnvironment" type="_HLvXoB5pEeW1E_G5zMqVNw"/>
@@ -180,8 +180,8 @@
       <packagedElement xmi:type="uml:Component" xmi:id="_HLvXoB5pEeW1E_G5zMqVNw" name="IXTestEnvironment">
         <ownedAttribute xmi:type="uml:Port" xmi:id="_hhHWoB5uEeWQp4RJeR2nOg" name="pocdpatienttestport" visibility="public" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Interface" href="hssp_pilot_libs/IXS.uml#_st20gBwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Interface" href="IXS.uml#_st20gBwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
         <ownedAttribute xmi:type="uml:Port" xmi:id="_GVLUUB5vEeWQp4RJeR2nOg" name="metadatatestport" visibility="public" aggregation="composite" isConjugated="true">
-          <type xmi:type="uml:Interface" href="hssp_pilot_libs/IXS.uml#_tLImYBwAEeWtNMMjZV-FEA"/>
+          <type xmi:type="uml:Interface" href="IXS.uml#_tLImYBwAEeWtNMMjZV-FEA"/>
         </ownedAttribute>
       </packagedElement>